#include <iostream>
#include <cassert>
using namespace std;
typedef long long ll;
#define TASK "queries"

const int N = 1000;
int cnt[N + 5];

int substitute(string q, int num) {
    int res = 0;
    for (int i = 0; i < q.size(); ++i)
        if (q[i] == '?') {
            res = res * 10 + num % 10;
            num /= 10;
        } else
            res = res * 10 + q[i] - '0';
    return res;
}

int main() {
    freopen(TASK".in", "r", stdin);
    freopen(TASK".out", "w", stdout);

    int n, m;
    cin >> n >> m;
    assert(n <= N && m <= N);
    for (int i = 0; i < n; ++i) {
        int x;
        cin >> x;
        assert(x < N);
        cnt[x]++;
    }
    for (int i = N - 1; i >= 0; --i)
        cnt[i] += cnt[i + 1];
    for (int i = 0; i < m; ++i) {
        string s;
        cin >> s;
        assert(s.size() <= 3);
        int ans = 0, k = 0;
        for (int j = 0; j < s.size(); ++j)
            k += s[j] == '?';
        int pw = 1;
        for (int p = 1; p <= k; ++p) pw *= 10;
        for (int num = 0; num < pw; ++num)
            ans += cnt[substitute(s, num)];
        cout << ans << endl;
    }

/*
10 7
1 2 3 66 10 20 34 48 50 103
1?1
0?1
???
??0
?03
101
104
*/
    return 0;
}